Attribute VB_Name = "mSCINERAlpha"
Option Explicit

Private Declare Function AlphaBlending Lib "msimg32.dll" Alias "AlphaBlend" (ByVal hdcDest As Long, ByVal nXOriginDest As Long, ByVal nYOriginDest As Long, ByVal nWidthDest As Long, ByVal nHeightDest As Long, ByVal hdcSrc As Long, ByVal nXOriginSrc As Long, ByVal nYOriginSrc As Long, ByVal nWidthSrc As Long, ByVal nHeightSrc As Long, ByVal BF As Long) As Long
Private Declare Function DrawTransparent Lib "msimg32.dll" Alias "TransparentBlt" (ByVal hdcDest As Long, ByVal nXOriginDest As Long, ByVal nYOriginDest As Long, ByVal nWidthDest As Long, ByVal nHeightDest As Long, ByVal hdcSrc As Long, ByVal nXOriginSrc As Long, ByVal nYOriginSrc As Long, ByVal nWidthSrc As Long, ByVal nHeightSrc As Long, ByVal crTransparent As Long) As Long

Type POINTAPI
  X As Long
  Y As Long
  End Type

Type RGBQUAD
  rgbBlue As Byte
  rgbGreen As Byte
  rgbRed As Byte
  rgbReserved As Byte
  End Type

Type BITMAPINFOHEADER
  biSize As Long
  biWidth As Long
  biHeight As Long
  biPlanes As Integer
  biBitCount As Integer
  biCompression As Long
  biSizeImage As Long
  biXPelsPerMeter As Long
  biYPelsPerMeter As Long
  biClrUsed As Long
  biClrImportant As Long
  End Type

Type BITMAPINFO
  bmiHeader As BITMAPINFOHEADER
  bmiColors As RGBQUAD
  End Type

'API Calls
Public Declare Function GetTickCount Lib "kernel32" () As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function SetPixelV Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function StretchBlt Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function CreateBitmap Lib "gdi32" (ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long, ByVal nBitCount As Long, lpBits As Any) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hDC As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function SetBkColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Private Declare Function SetDIBits Lib "gdi32" (ByVal hDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Private Declare Function SetDIBitsToDevice Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal DX As Long, ByVal dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal Scan As Long, ByVal NumScans As Long, Bits As Any, BitsInfo As BITMAPINFO, ByVal wUsage As Long) As Long

Dim AlphaTable(255, 255, 1 To 254) As Byte

Function AlphaBlend2(ByVal hDstDC As Long, ByVal DstX As Long, ByVal DstY As Long, ByVal Width As Long, ByVal Height As Long, ByVal hSrcDC As Long, ByVal ShadowDC As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal TransColor As Long, ByVal Flags As Long) As Long

  If Width < 1 Or Height < 1 Then Exit Function

  Dim B As Long, H As Long, F As Long, i As Long
  Dim TmpDC As Long, TmpBmp As Long, TmpObj As Long
  Dim Sr2DC As Long, Sr2Bmp As Long, Sr2Obj As Long
  Dim ShDC As Long, ShBmp As Long, ShObj As Long
  Dim Data1() As Long, Data2() As Long, Data3() As Long
  Dim Info As BITMAPINFO
  Dim A#, R1&, G1&, B1&, R2&, G2&, B2&

  TmpDC = CreateCompatibleDC(hSrcDC)
  Sr2DC = CreateCompatibleDC(hSrcDC)
  ShDC = CreateCompatibleDC(ShadowDC)
  TmpBmp = CreateCompatibleBitmap(hDstDC, Width, Height)
  Sr2Bmp = CreateCompatibleBitmap(hDstDC, Width, Height)
  ShBmp = CreateCompatibleBitmap(hDstDC, Width, Height)
  TmpObj = SelectObject(TmpDC, TmpBmp)
  Sr2Obj = SelectObject(Sr2DC, Sr2Bmp)
  ShObj = SelectObject(ShDC, ShBmp)

  ReDim Data1(Width * Height * 4 - 1)
  ReDim Data2(Width * Height * 4 - 1)
  ReDim Data3(Width * Height * 4 - 1)

  Info.bmiHeader.biSize = Len(Info.bmiHeader)
  Info.bmiHeader.biWidth = Width
  Info.bmiHeader.biHeight = Height
  Info.bmiHeader.biPlanes = 1
  Info.bmiHeader.biBitCount = 32
  Info.bmiHeader.biCompression = 0

  If BitBlt(TmpDC, 0, 0, Width, Height, hDstDC, DstX, DstY, vbSrcCopy) = 0 Then GoTo ExitFromIt
  If BitBlt(Sr2DC, 0, 0, Width, Height, hSrcDC, SrcX, SrcY, vbSrcCopy) = 0 Then GoTo ExitFromIt
  If BitBlt(ShDC, 0, 0, Width, Height, ShadowDC, SrcX, SrcY, vbSrcCopy) = 0 Then GoTo ExitFromIt
  GetDIBits TmpDC, TmpBmp, 0, Height, Data1(0), Info, 0
  GetDIBits Sr2DC, Sr2Bmp, 0, Height, Data2(0), Info, 0
  GetDIBits ShDC, ShBmp, 0, Height, Data3(0), Info, 0

  For H = 0 To Height - 1
      F = H * Width
      For B = 0 To Width - 1
          i = F + B

          B1 = Data1(i)
          R1 = B1 Mod 256
          G1 = (B1 \ 256) Mod 256
          B1 = B1 \ 256 \ 256

          A = (255 - Data2(i) Mod 256) / 255
          
          B2 = Data3(i)
          R2 = B2 Mod 256
          G2 = (B2 \ 256) Mod 256
          B2 = B2 \ 256 \ 256
          

          R1 = (A * R1) - (A - 1) * R2
          G1 = (A * G1) - (A - 1) * G2
          B1 = (A * B1) - (A - 1) * B2

          Data1(i) = RGB(R1, G1, B1)
      
      Next B
  Next H

  AlphaBlend2 = SetDIBitsToDevice(hDstDC, DstX, DstY, Width, Height, 0, 0, 0, Height, Data1(0), Info, 0)

  Erase Data1
  Erase Data2
  Erase Data3

ExitFromIt:

  DeleteObject SelectObject(TmpDC, TmpObj)
  DeleteObject SelectObject(Sr2DC, Sr2Obj)
  DeleteObject SelectObject(ShDC, ShObj)
  DeleteDC TmpDC
  DeleteDC TmpBmp
  DeleteDC Sr2DC
  DeleteDC Sr2Bmp
  DeleteDC ShDC
  DeleteDC ShBmp

End Function



















Function AlphaBlend3(ByVal hDstDC As Long, ByVal DstX As Long, ByVal DstY As Long, ByVal Width As Long, ByVal Height As Long, ByVal hSrcDC As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal TransColor As Long, ByVal Flags As Long, ByVal Alpha As Byte) As Long

  If Alpha > 254 Or Width < 1 Or Height < 1 Then Exit Function
  If Alpha < 1 Then
  BitBlt hDstDC, DstX, DstY, Width, Height, hSrcDC, SrcX, SrcY, vbSrcCopy
  Exit Function
  End If

  Dim B As Long, i As Long
  Dim TmpDC As Long, TmpBmp As Long, TmpObj As Long
  Dim Sr2DC As Long, Sr2Bmp As Long, Sr2Obj As Long
  Dim Data1() As Byte, Data2() As Byte
  Dim Info As BITMAPINFO
  Dim A#

  TmpDC = CreateCompatibleDC(hSrcDC)
  Sr2DC = CreateCompatibleDC(hSrcDC)
  TmpBmp = CreateCompatibleBitmap(hDstDC, Width, Height)
  Sr2Bmp = CreateCompatibleBitmap(hDstDC, Width, Height)
  TmpObj = SelectObject(TmpDC, TmpBmp)
  Sr2Obj = SelectObject(Sr2DC, Sr2Bmp)

  ReDim Data1(Width * Height * 4 - 1)
  ReDim Data2(UBound(Data1))

  Info.bmiHeader.biSize = 40
  Info.bmiHeader.biWidth = Width
  Info.bmiHeader.biHeight = Height
  Info.bmiHeader.biPlanes = 1
  Info.bmiHeader.biBitCount = 32
  Info.bmiHeader.biCompression = 0

  If BitBlt(TmpDC, 0, 0, Width, Height, hDstDC, DstX, DstY, vbSrcCopy) = 0 Then GoTo ExitFromIt
  If BitBlt(Sr2DC, 0, 0, Width, Height, hSrcDC, SrcX, SrcY, vbSrcCopy) = 0 Then GoTo ExitFromIt
  GetDIBits TmpDC, TmpBmp, 0, Height, Data1(0), Info, 0
  GetDIBits Sr2DC, Sr2Bmp, 0, Height, Data2(0), Info, 0

  A = Alpha / 255
  
  Select Case TransColor
  Case 0
    For i = 0 To UBound(Data1) Step 4
      Data1(i + 0) = (A * Data1(i + 0)) - (A - 1) * Data2(i + 0)
      Data1(i + 1) = (A * Data1(i + 1)) - (A - 1) * Data2(i + 1)
      Data1(i + 2) = (A * Data1(i + 2)) - (A - 1) * Data2(i + 2)
    Next
  Case 1
    For i = 0 To UBound(Data1) Step 4
      Data1(i + 1) = (A * Data1(i + 1)) - (A - 1) * Data2(i + 1)
      Data1(i + 2) = (A * Data1(i + 2)) - (A - 1) * Data2(i + 2)
    Next
  Case 2
    For i = 0 To UBound(Data1) Step 4
      Data1(i + 0) = (A * Data1(i + 0)) - (A - 1) * Data2(i + 0)
      Data1(i + 2) = (A * Data1(i + 2)) - (A - 1) * Data2(i + 2)
    Next
  Case 3
    For i = 0 To UBound(Data1) Step 4
      Data1(i + 0) = (A * Data1(i + 0)) - (A - 1) * Data2(i + 0)
      Data1(i + 1) = (A * Data1(i + 1)) - (A - 1) * Data2(i + 1)
    Next
  Case 4
    For i = 0 To UBound(Data1) Step 4
      Data1(i + 2) = (A * Data1(i + 2)) - (A - 1) * Data2(i + 2)
    Next
  Case 5
    For i = 0 To UBound(Data1) Step 4
      Data1(i + 1) = (A * Data1(i + 1)) - (A - 1) * Data2(i + 1)
    Next
  Case Else
    For i = 0 To UBound(Data1) Step 4
      Data1(i + 0) = (A * Data1(i + 0)) - (A - 1) * Data2(i + 0)
    Next
  End Select

  AlphaBlend3 = SetDIBitsToDevice(hDstDC, DstX, DstY, Width, Height, 0, 0, 0, Height, Data1(0), Info, 0)

  Erase Data1
  Erase Data2

ExitFromIt:

  DeleteObject SelectObject(TmpDC, TmpObj)
  DeleteObject SelectObject(Sr2DC, Sr2Obj)
  DeleteDC TmpDC
  DeleteDC TmpBmp
  DeleteDC Sr2DC
  DeleteDC Sr2Bmp

End Function



Sub InitAlphaTable()
  Dim Alpha#, A&, X&, Y&
  For A = 1 To 254
    Alpha = A / 255
    For X = 0 To 255
      For Y = 0 To 255
        AlphaTable(X, Y, A) = (Alpha * X) - (Alpha - 1) * Y
      Next
    Next
  Next
  End Sub


Function AlphaBlend4(ByVal hDstDC As Long, ByVal DstX As Long, ByVal DstY As Long, ByVal Width As Long, ByVal Height As Long, ByVal hSrcDC As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal TransColor As Long, ByVal Flags As Long, ByVal Alpha As Byte) As Long

  If Alpha > 254 Or Width < 1 Or Height < 1 Then Exit Function
  If Alpha < 1 Then
  BitBlt hDstDC, DstX, DstY, Width, Height, hSrcDC, SrcX, SrcY, vbSrcCopy
  Exit Function
  End If

  Dim B As Long, i As Long
  Dim TmpDC As Long, TmpBmp As Long, TmpObj As Long
  Dim Sr2DC As Long, Sr2Bmp As Long, Sr2Obj As Long
  Dim Data1() As Byte, Data2() As Byte
  Dim Info As BITMAPINFO
  Dim A#

  TmpDC = CreateCompatibleDC(hSrcDC)
  Sr2DC = CreateCompatibleDC(hSrcDC)
  TmpBmp = CreateCompatibleBitmap(hDstDC, Width, Height)
  Sr2Bmp = CreateCompatibleBitmap(hDstDC, Width, Height)
  TmpObj = SelectObject(TmpDC, TmpBmp)
  Sr2Obj = SelectObject(Sr2DC, Sr2Bmp)

  ReDim Data1(Width * Height * 4 - 1)
  ReDim Data2(UBound(Data1))

  Info.bmiHeader.biSize = 40
  Info.bmiHeader.biWidth = Width
  Info.bmiHeader.biHeight = Height
  Info.bmiHeader.biPlanes = 1
  Info.bmiHeader.biBitCount = 32
  Info.bmiHeader.biCompression = 0

  If BitBlt(TmpDC, 0, 0, Width, Height, hDstDC, DstX, DstY, vbSrcCopy) = 0 Then GoTo ExitFromIt
  If BitBlt(Sr2DC, 0, 0, Width, Height, hSrcDC, SrcX, SrcY, vbSrcCopy) = 0 Then GoTo ExitFromIt
  GetDIBits TmpDC, TmpBmp, 0, Height, Data1(0), Info, 0
  GetDIBits Sr2DC, Sr2Bmp, 0, Height, Data2(0), Info, 0

  For i = 0 To UBound(Data1) Step 4
    Data1(i + 0) = AlphaTable(Data1(i + 0), Data2(i + 0), Alpha)
    Data1(i + 1) = AlphaTable(Data1(i + 1), Data2(i + 1), Alpha)
    Data1(i + 2) = AlphaTable(Data1(i + 2), Data2(i + 2), Alpha)
  Next

  AlphaBlend4 = SetDIBitsToDevice(hDstDC, DstX, DstY, Width, Height, 0, 0, 0, Height, Data1(0), Info, 0)

  Erase Data1
  Erase Data2

ExitFromIt:

  DeleteObject SelectObject(TmpDC, TmpObj)
  DeleteObject SelectObject(Sr2DC, Sr2Obj)
  DeleteDC TmpDC
  DeleteDC TmpBmp
  DeleteDC Sr2DC
  DeleteDC Sr2Bmp

End Function













































Function AlphaBlend(ByVal hDstDC As Long, ByVal DstX As Long, ByVal DstY As Long, ByVal Width As Long, ByVal Height As Long, ByVal hSrcDC As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal Alpha As Byte, ByVal TransColor As Long, ByVal Flags As Integer) As Long

  If Alpha <= 0 Or Width <= 0 Or Height <= 0 Then Exit Function

  If Alpha >= 255 Then
    BitBlt hDstDC, DstX, DstY, Width, Height, hSrcDC, 0, 0, vbSrcCopy
    Exit Function
  End If

  Dim B As Long, H As Long, F As Long, i As Long
  Dim TmpDC As Long, TmpBmp As Long, TmpObj As Long
  Dim Sr2DC As Long, Sr2Bmp As Long, Sr2Obj As Long
  Dim Data1() As Long, Data2() As Long
  Dim Info As BITMAPINFO

  TmpDC = CreateCompatibleDC(hSrcDC)
  Sr2DC = CreateCompatibleDC(hSrcDC)
  TmpBmp = CreateCompatibleBitmap(hDstDC, Width, Height)
  Sr2Bmp = CreateCompatibleBitmap(hDstDC, Width, Height)
  TmpObj = SelectObject(TmpDC, TmpBmp)
  Sr2Obj = SelectObject(Sr2DC, Sr2Bmp)

  ReDim Data1(Width * Height * 4 - 1)
  ReDim Data2(Width * Height * 4 - 1)

  Info.bmiHeader.biSize = Len(Info.bmiHeader)
  Info.bmiHeader.biWidth = Width
  Info.bmiHeader.biHeight = Height
  Info.bmiHeader.biPlanes = 1
  Info.bmiHeader.biBitCount = 32
  Info.bmiHeader.biCompression = 0

  If BitBlt(TmpDC, 0, 0, Width, Height, hDstDC, DstX, DstY, vbSrcCopy) = 0 Then GoTo ExitFromIt
  If BitBlt(Sr2DC, 0, 0, Width, Height, hSrcDC, SrcX, SrcY, vbSrcCopy) = 0 Then GoTo ExitFromIt

  GetDIBits TmpDC, TmpBmp, 0, Height, Data1(0), Info, 0
  GetDIBits Sr2DC, Sr2Bmp, 0, Height, Data2(0), Info, 0

  For H = 0 To Height - 1
      F = H * Width
      For B = 0 To Width - 1
          i = F + B
          If Not (Flags And &H1) And Not ((Data2(i) And &HFFFFFF) = TransColor) Then
          Data1(i) = ShadeColors(Data1(i), Data2(i), Alpha)
          End If
      Next B
  Next H

  AlphaBlend = SetDIBitsToDevice(hDstDC, DstX, DstY, Width, Height, 0, 0, 0, Height, Data1(0), Info, 0)

  Erase Data1
  Erase Data2

ExitFromIt:

  DeleteObject SelectObject(TmpDC, TmpObj)
  DeleteObject SelectObject(Sr2DC, Sr2Obj)
  DeleteDC TmpDC
  DeleteDC TmpBmp
  DeleteDC Sr2DC
  DeleteDC Sr2Bmp

End Function

Private Function ShadeColors(ByVal Dst As Long, ByVal Src As Long, ByVal Shade As Byte) As Long

  Select Case Shade

    Case Is <= 0
      ShadeColors = Dst

    Case Is >= 255
      ShadeColors = Src

    Case Else
      ShadeColors = (Src And &HFF) * Shade / 255 + (Dst And &HFF) * (255 - Shade) / 255 Or ((Src And &HFF00&) * Shade / 255 + (Dst And &HFF00&) * (255 - Shade) / 255) And &HFF00& Or ((Src And &HFF0000) * (Shade / 255) + (Dst And &HFF0000) * ((255 - Shade) / 255)) And &HFF0000

  End Select

End Function


Public Function AlphaBlendAPI(ByVal destHDC As Long, ByVal XDest As Long, ByVal YDest As Long, ByVal destWidth As Long, ByVal destHeight As Long, ByVal srcHDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal srcWidth As Long, ByVal srcHeight As Long, ByVal AlphaSource As Long) As Long
  Dim lngBlend As Long
  lngBlend = Val("&h" & Hex(AlphaSource) & "00" & "00")
  AlphaBlending destHDC, XDest, YDest, destWidth, destHeight, srcHDC, xSrc, ySrc, srcWidth, srcHeight, lngBlend
End Function

Public Function TransparentBlt(ByVal destHDC As Long, ByVal XDest As Long, ByVal YDest As Long, ByVal destWidth As Long, ByVal destHeight As Long, ByVal srcHDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal srcWidth As Long, ByVal srcHeight As Long, ByVal TransparentColor As Long) As Long
  DrawTransparent destHDC, XDest, YDest, destWidth, destHeight, srcHDC, xSrc, ySrc, srcWidth, srcHeight, TransparentColor
End Function



